module DisableUITestModule
	def self.test_disable_ui
	# needs a model that has *only* one main group containing at least 4 sub-groups, each a cube, say, or something else...
	# the test is to be run with the Outliner open and the console panel displayed
		Sketchup.send_action('showRubyPanel:')
		sam = Sketchup.active_model
		main_group = sam.entities.to_a.find_all {|g| g.class==Sketchup::Group}[0]
		#
		group_ok = main_group.nil? ? false : true
		group_ok = false if group_ok && main_group.entities.length < 4
		UI.messagebox('Group not found with a minimum of 4 sub-groups for testing - more is better...') unless group_ok
		return unless group_ok
		#
		test_layer = sam.layers['test'] # used to see if Layers window is updated
		#
		sub_groups = main_group.entities.to_a.sort_by {|g| g.name} # just for visual esthetics :-)
		sub_groups.each {|g| g.visible=true}
		#
		run_test=lambda {
			sub_groups.each {|g| sam.layers.remove(g.name, false) if sam.layers[g.name]} # remove sub_group layers each test
			test_layer.visible=false
			disable_ui = UI.messagebox("Click 'Yes' to disable UI or 'No' to enable UI.\nEnsure that the Outliner window is open.", MB_YESNO)==IDYES ? true : false
			puts("operation will run with disable_ui set to: #{disable_ui}")
			sam.start_operation('test_disable_ui', disable_ui) # if disable_ui
			sleep(1)
			sub_groups.each_with_index {|g,i|
				sg_layer=sam.layers.add(g.name)
				g.layer=sg_layer
				msg="selecting group #{g.name}..."
				puts(msg); Sketchup.status_text=msg
				test_layer.visible = !test_layer.visible?
				sleep(1)
				g.visible=false
				sam.active_view.refresh # if i.modulo(2).zero? #&& !disable_ui
			} # each sub_groups
			#
			msg="finished selecting groups..."
			puts(msg); Sketchup.status_text=msg
			sleep(1)
			sub_groups.each {|g| g.visible=true}
			sam.commit_operation
		} # run_test
		#
		while true
			run_test.call
			break if UI.messagebox("Click OK to run again or Cancel to end", MB_OKCANCEL) == IDCANCEL
		end # while
		#
		msg =  "Setting 'disable_ui' to true affects *neither* the status bar *nor* the console.\n"
		msg << "It *does* disable updating of the viewport, *but* this will be overridden if the view.refresh method is used.\n\n"
		msg << "The view.refresh methods that were inside scripts have caused the belief that the disable_ui parameter didn't affect the viewport... :-(\n"
		msg << "\nThe good news is that disable_UI *also* disables the Outliner.\n"
		msg << "\nApparently, the Layers window is *never* updated whilst a script is running - with or without an operation started, with or without disable_ui..."
		UI.messagebox(msg)
		puts('disable UI test ended')
		#
	end # def test_disable_ui
end # module DisableUITestModule